Index: src/unittests/tesselation_boundarytriangleunittest.cpp
===================================================================
--- src/unittests/tesselation_boundarytriangleunittest.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/tesselation_boundarytriangleunittest.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -35,23 +35,22 @@
 
   // create nodes
-  TesselPoint *Walker = NULL;
-  Walker = new TesselPoint;
-  Walker->node = new Vector(0., 0., 0.);
-  Walker->Name = Malloc<char>(3, "TesselationBoundaryTriangleTest::setUp - *Name");
-  strcpy(Walker->Name, "1");
-  Walker->nr = 1;
-  points[0] = new BoundaryPointSet(Walker);
-  Walker = new TesselPoint;
-  Walker->node = new Vector(0., 1., 0.);
-  Walker->Name = Malloc<char>(3, "TesselationBoundaryTriangleTest::setUp - *Name");
-  strcpy(Walker->Name, "2");
-  Walker->nr = 2;
-  points[1] = new BoundaryPointSet(Walker);
-  Walker = new TesselPoint;
-  Walker->node = new Vector(1., 0., 0.);
-  Walker->Name = Malloc<char>(3, "TesselationBoundaryTriangleTest::setUp - *Name");
-  strcpy(Walker->Name, "3");
-  Walker->nr = 3;
-  points[2] = new BoundaryPointSet(Walker);
+  tesselpoints[0] = new TesselPoint;
+  tesselpoints[0]->node = new Vector(0., 0., 0.);
+  tesselpoints[0]->Name = Malloc<char>(3, "TesselationBoundaryTriangleTest::setUp - *Name");
+  strcpy(tesselpoints[0]->Name, "1");
+  tesselpoints[0]->nr = 1;
+  points[0] = new BoundaryPointSet(tesselpoints[0]);
+  tesselpoints[1] = new TesselPoint;
+  tesselpoints[1]->node = new Vector(0., 1., 0.);
+  tesselpoints[1]->Name = Malloc<char>(3, "TesselationBoundaryTriangleTest::setUp - *Name");
+  strcpy(tesselpoints[1]->Name, "2");
+  tesselpoints[1]->nr = 2;
+  points[1] = new BoundaryPointSet(tesselpoints[1]);
+  tesselpoints[2] = new TesselPoint;
+  tesselpoints[2] ->node = new Vector(1., 0., 0.);
+  tesselpoints[2] ->Name = Malloc<char>(3, "TesselationBoundaryTriangleTest::setUp - *Name");
+  strcpy(tesselpoints[2] ->Name, "3");
+  tesselpoints[2] ->nr = 3;
+  points[2] = new BoundaryPointSet(tesselpoints[2] );
 
   // create line
@@ -69,4 +68,9 @@
 {
   delete(triangle);
+  for (int i=0;i<3;++i) {
+    // TesselPoint does not delete its vector as it only got a reference
+    delete tesselpoints[i]->node;
+    delete tesselpoints[i];
+  }
   MemoryUsageObserver::purgeInstance();
   logger::purgeInstance();
@@ -82,49 +86,49 @@
 
   // simple test on y line
-  Point.Init(-1.,0.5,0.);
-  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.,0.5,0.);
-  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
-  Point.Init(-4.,0.5,0.);
+  Point = Vector(-1.,0.5,0.);
+  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  Point = Vector(0.,0.5,0.);
+  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
+  Point = Vector(-4.,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( 16., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.,0.5,0.);
+  Point = Vector(0.,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on x line
-  Point.Init(0.5,-1.,0.);
-  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.5,0.,0.);
-  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
-  Point.Init(0.5,-6.,0.);
+  Point = Vector(0.5,-1.,0.);
+  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  Point = Vector(0.5,0.,0.);
+  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
+  Point = Vector(0.5,-6.,0.);
   CPPUNIT_ASSERT_EQUAL( 36., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.5,0.,0.);
+  Point = Vector(0.5,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on slanted line
-  Point.Init(1.,1.,0.);
+  Point = Vector(1.,1.,0.);
   CPPUNIT_ASSERT_EQUAL( 0.5, triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.5,0.5,0.);
-  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
-  Point.Init(5.,5.,0.);
+  Point = Vector(0.5,0.5,0.);
+  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
+  Point = Vector(5.,5.,0.);
   CPPUNIT_ASSERT_EQUAL( 40.5, triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.5,0.5,0.);
+  Point = Vector(0.5,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on first node
-  Point.Init(-1.,-1.,0.);
+  Point = Vector(-1.,-1.,0.);
   CPPUNIT_ASSERT_EQUAL( 2., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.,0.,0.);
+  Point = Vector(0.,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on second node
-  Point.Init(0.,2.,0.);
-  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.,1.,0.);
+  Point = Vector(0.,2.,0.);
+  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  Point = Vector(0.,1.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on third node
-  Point.Init(2.,0.,0.);
-  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(1.,0.,0.);
+  Point = Vector(2.,0.,0.);
+  CPPUNIT_ASSERT_EQUAL( 1., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
+  Point = Vector(1.,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 };
@@ -138,59 +142,59 @@
 
   // straight down/up
-  Point.Init(1./3.,1./3.,+5.);
+  Point = Vector(1./3.,1./3.,+5.);
   CPPUNIT_ASSERT_EQUAL( 25. , triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(1./3.,1./3.,0.);
-  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
-  Point.Init(1./3.,1./3.,-5.);
+  Point = Vector(1./3.,1./3.,0.);
+  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
+  Point = Vector(1./3.,1./3.,-5.);
   CPPUNIT_ASSERT_EQUAL( 25. , triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(1./3.,1./3.,0.);
+  Point = Vector(1./3.,1./3.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on y line
-  Point.Init(-1.,0.5,+2.);
+  Point = Vector(-1.,0.5,+2.);
   CPPUNIT_ASSERT_EQUAL( 5., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.,0.5,0.);
-  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
-  Point.Init(-1.,0.5,-3.);
+  Point = Vector(0.,0.5,0.);
+  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
+  Point = Vector(-1.,0.5,-3.);
   CPPUNIT_ASSERT_EQUAL( 10., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.,0.5,0.);
+  Point = Vector(0.,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on x line
-  Point.Init(0.5,-1.,+1.);
+  Point = Vector(0.5,-1.,+1.);
   CPPUNIT_ASSERT_EQUAL( 2., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.5,0.,0.);
-  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
-  Point.Init(0.5,-1.,-2.);
+  Point = Vector(0.5,0.,0.);
+  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
+  Point = Vector(0.5,-1.,-2.);
   CPPUNIT_ASSERT_EQUAL( 5., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.5,0.,0.);
+  Point = Vector(0.5,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on slanted line
-  Point.Init(1.,1.,+3.);
+  Point = Vector(1.,1.,+3.);
   CPPUNIT_ASSERT_EQUAL( 9.5, triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.5,0.5,0.);
-  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
-  Point.Init(1.,1.,-4.);
+  Point = Vector(0.5,0.5,0.);
+  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
+  Point = Vector(1.,1.,-4.);
   CPPUNIT_ASSERT_EQUAL( 16.5, triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.5,0.5,0.);
+  Point = Vector(0.5,0.5,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on first node
-  Point.Init(-1.,-1.,5.);
+  Point = Vector(-1.,-1.,5.);
   CPPUNIT_ASSERT_EQUAL( 27., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.,0.,0.);
+  Point = Vector(0.,0.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on second node
-  Point.Init(0.,2.,5.);
+  Point = Vector(0.,2.,5.);
   CPPUNIT_ASSERT_EQUAL( 26., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(0.,1.,0.);
+  Point = Vector(0.,1.,0.);
   CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
 
   // simple test on third node
-  Point.Init(2.,0.,5.);
+  Point = Vector(2.,0.,5.);
   CPPUNIT_ASSERT_EQUAL( 26., triangle->GetClosestPointInsideTriangle(&Point, &TestIntersection) );
-  Point.Init(1.,0.,0.);
-  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
-};
+  Point = Vector(1.,0.,0.);
+  CPPUNIT_ASSERT_EQUAL( true , Point == TestIntersection );
+};
Index: src/unittests/tesselation_boundarytriangleunittest.hpp
===================================================================
--- src/unittests/tesselation_boundarytriangleunittest.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/tesselation_boundarytriangleunittest.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -35,5 +35,6 @@
       class BoundaryLineSet *lines[3];
       class BoundaryPointSet *points[3];
-      LinkedNodes Corners;
+      class TesselPoint *tesselpoints[3];
+      LinkedCell::LinkedNodes Corners;
 };
 
Index: src/unittests/tesselation_insideoutsideunittest.cpp
===================================================================
--- src/unittests/tesselation_insideoutsideunittest.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/tesselation_insideoutsideunittest.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -98,7 +98,7 @@
   while ((!TesselStruct->OpenLines.empty()) && (OneLoopWithoutSuccessFlag)) {
     // 2a. fill all new OpenLines
-    Log() << Verbose(1) << "There are " << TesselStruct->OpenLines.size() << " open lines to scan for candidates:" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "There are " << TesselStruct->OpenLines.size() << " open lines to scan for candidates:" << endl);
     for (CandidateMap::iterator Runner = TesselStruct->OpenLines.begin(); Runner != TesselStruct->OpenLines.end(); Runner++)
-      Log() << Verbose(2) << *(Runner->second) << endl;
+      DoLog(2) && (Log() << Verbose(2) << *(Runner->second) << endl);
 
     for (CandidateMap::iterator Runner = TesselStruct->OpenLines.begin(); Runner != TesselStruct->OpenLines.end(); Runner++) {
@@ -106,5 +106,5 @@
       if (baseline->pointlist.empty()) {
         T = (((baseline->BaseLine->triangles.begin()))->second);
-        Log() << Verbose(1) << "Finding best candidate for open line " << *baseline->BaseLine << " of triangle " << *T << endl;
+        DoLog(1) && (Log() << Verbose(1) << "Finding best candidate for open line " << *baseline->BaseLine << " of triangle " << *T << endl);
         TesselationFailFlag = TesselStruct->FindNextSuitableTriangle(*baseline, *T, SPHERERADIUS, LinkedList); //the line is there, so there is a triangle, but only one.
       }
@@ -113,7 +113,7 @@
     // 2b. search for smallest ShortestAngle among all candidates
     double ShortestAngle = 4.*M_PI;
-    Log() << Verbose(1) << "There are " << TesselStruct->OpenLines.size() << " open lines to scan for the best candidates:" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "There are " << TesselStruct->OpenLines.size() << " open lines to scan for the best candidates:" << endl);
     for (CandidateMap::iterator Runner = TesselStruct->OpenLines.begin(); Runner != TesselStruct->OpenLines.end(); Runner++)
-      Log() << Verbose(2) << *(Runner->second) << endl;
+      DoLog(2) && (Log() << Verbose(2) << *(Runner->second) << endl);
 
     for (CandidateMap::iterator Runner = TesselStruct->OpenLines.begin(); Runner != TesselStruct->OpenLines.end(); Runner++) {
@@ -127,5 +127,5 @@
       OneLoopWithoutSuccessFlag = false;
     else {
-      TesselStruct->AddCandidateTriangle(*baseline);
+      TesselStruct->AddCandidatePolygon(*baseline, SPHERERADIUS, LinkedList);
     }
   }
@@ -137,5 +137,5 @@
   delete(LinkedList);
   delete(TesselStruct);
-  for (LinkedNodes::iterator Runner = Corners.begin(); Runner != Corners.end(); Runner++) {
+  for (LinkedCell::LinkedNodes::iterator Runner = Corners.begin(); Runner != Corners.end(); Runner++) {
     delete((*Runner)->node);
     delete(*Runner);
Index: src/unittests/tesselation_insideoutsideunittest.hpp
===================================================================
--- src/unittests/tesselation_insideoutsideunittest.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/tesselation_insideoutsideunittest.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -31,5 +31,5 @@
 private:
       class Tesselation *TesselStruct;
-      LinkedNodes Corners;
+      LinkedCell::LinkedNodes Corners;
       class LinkedCell *LinkedList;
 };
Index: src/unittests/tesselationunittest.cpp
===================================================================
--- src/unittests/tesselationunittest.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/tesselationunittest.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -95,5 +95,5 @@
       OneLoopWithoutSuccessFlag = false;
     else {
-      TesselStruct->AddCandidateTriangle(*baseline);
+      TesselStruct->AddCandidatePolygon(*baseline, SPHERERADIUS, LinkedList);
     }
   }
@@ -105,5 +105,5 @@
   delete(LinkedList);
   delete(TesselStruct);
-  for (LinkedNodes::iterator Runner = Corners.begin(); Runner != Corners.end(); Runner++) {
+  for (LinkedCell::LinkedNodes::iterator Runner = Corners.begin(); Runner != Corners.end(); Runner++) {
     delete((*Runner)->node);
     delete(*Runner);
Index: src/unittests/tesselationunittest.hpp
===================================================================
--- src/unittests/tesselationunittest.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/tesselationunittest.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -34,5 +34,5 @@
 private:
       class Tesselation *TesselStruct;
-      LinkedNodes Corners;
+      LinkedCell::LinkedNodes Corners;
       class LinkedCell *LinkedList;
 };
Index: src/unittests/vectorunittest.cpp
===================================================================
--- src/unittests/vectorunittest.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/vectorunittest.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -14,6 +14,11 @@
 
 #include "defs.hpp"
+#include "log.hpp"
+#include "memoryusageobserver.hpp"
 #include "vector.hpp"
+#include "vector_ops.hpp"
 #include "vectorunittest.hpp"
+#include "Plane.hpp"
+#include "Exceptions/LinearDependenceException.hpp"
 
 #ifdef HAVE_TESTRUNNER
@@ -21,4 +26,8 @@
 #endif /*HAVE_TESTRUNNER*/
 
+#include <iostream>
+
+using namespace std;
+
 /********************************************** Test classes **************************************/
 
@@ -29,9 +38,10 @@
 void VectorTest::setUp()
 {
-  zero.Init(0.,0.,0.);
-  unit.Init(1.,0.,0.);
-  otherunit.Init(0.,1.,0.);
-  notunit.Init(0.,1.,1.);
-  two.Init(2.,1.,0.);
+  zero  = Vector(0.,0.,0.);
+  unit = Vector(1.,0.,0.);
+  otherunit = Vector(0.,1.,0.);
+  notunit = Vector(0.,1.,1.);
+  two = Vector(2.,1.,0.);
+  three = Vector(1,2,3);
 };
 
@@ -39,4 +49,7 @@
 void VectorTest::tearDown()
 {
+  MemoryUsageObserver::purgeInstance();
+  logger::purgeInstance();
+  errorLogger::purgeInstance();
 };
 
@@ -61,40 +74,29 @@
   double factor;
   // copy vector
-  fixture.Init(2.,3.,4.);
+  fixture = Vector(2.,3.,4.);
   CPPUNIT_ASSERT_EQUAL( Vector(2.,3.,4.), fixture );
   // summation and scaling
-  fixture.CopyVector(&zero);
-  fixture.AddVector(&unit);
-  CPPUNIT_ASSERT_EQUAL( true, fixture.IsOne() );
-  fixture.CopyVector(&zero);
-  fixture.SubtractVector(&unit);
+  fixture = zero + unit;
+  CPPUNIT_ASSERT_EQUAL( true, fixture.IsOne() );
+  fixture = zero - unit;
   CPPUNIT_ASSERT_EQUAL( true, fixture.IsOne() );
   CPPUNIT_ASSERT_EQUAL( false, fixture.IsZero() );
-  fixture.CopyVector(&zero);
-  fixture.AddVector(&zero);
+  fixture = zero + zero;
   CPPUNIT_ASSERT_EQUAL( true, fixture.IsZero() );
-  fixture.CopyVector(&notunit);
-  fixture.SubtractVector(&otherunit);
-  CPPUNIT_ASSERT_EQUAL( true, fixture.IsOne() );
-  fixture.CopyVector(&unit);
-  fixture.AddVector(&otherunit);
+  fixture = notunit - otherunit;
+  CPPUNIT_ASSERT_EQUAL( true, fixture.IsOne() );
+  fixture = unit - otherunit;
   CPPUNIT_ASSERT_EQUAL( false, fixture.IsOne() );
-  fixture.CopyVector(&notunit);
-  fixture.SubtractVector(&unit);
-  fixture.SubtractVector(&otherunit);
+  fixture = notunit - unit - otherunit;
   CPPUNIT_ASSERT_EQUAL( false, fixture.IsZero() );
-  fixture.CopyVector(&unit);
-  fixture.Scale(0.98);
+  fixture = 0.98 * unit;
   CPPUNIT_ASSERT_EQUAL( false, fixture.IsOne() );
-  fixture.CopyVector(&unit);
-  fixture.Scale(1.);
-  CPPUNIT_ASSERT_EQUAL( true, fixture.IsOne() );
-  fixture.CopyVector(&unit);
+  fixture = 1. * unit;
+  CPPUNIT_ASSERT_EQUAL( true, fixture.IsOne() );
   factor = 0.98;
-  fixture.Scale(factor);
+  fixture = factor * unit;
   CPPUNIT_ASSERT_EQUAL( false, fixture.IsOne() );
-  fixture.CopyVector(&unit);
   factor = 1.;
-  fixture.Scale(factor);
+  fixture = factor * unit;
   CPPUNIT_ASSERT_EQUAL( true, fixture.IsOne() );
 };
@@ -126,15 +128,15 @@
 void VectorTest::EuclidianScalarProductTest()
 {
-  CPPUNIT_ASSERT_EQUAL( 0., zero.ScalarProduct(&zero) );
-  CPPUNIT_ASSERT_EQUAL( 0., zero.ScalarProduct(&unit) );
-  CPPUNIT_ASSERT_EQUAL( 0., zero.ScalarProduct(&otherunit) );
-  CPPUNIT_ASSERT_EQUAL( 0., zero.ScalarProduct(&notunit) );
-  CPPUNIT_ASSERT_EQUAL( 1., unit.ScalarProduct(&unit) );
-  CPPUNIT_ASSERT_EQUAL( 0., otherunit.ScalarProduct(&unit) );
-  CPPUNIT_ASSERT_EQUAL( 0., otherunit.ScalarProduct(&unit) );
-  CPPUNIT_ASSERT_EQUAL( 1., otherunit.ScalarProduct(&notunit) );
-  CPPUNIT_ASSERT_EQUAL( 2., two.ScalarProduct(&unit) );
-  CPPUNIT_ASSERT_EQUAL( 1., two.ScalarProduct(&otherunit) );
-  CPPUNIT_ASSERT_EQUAL( 1., two.ScalarProduct(&notunit) );
+  CPPUNIT_ASSERT_EQUAL( 0., zero.ScalarProduct(zero) );
+  CPPUNIT_ASSERT_EQUAL( 0., zero.ScalarProduct(unit) );
+  CPPUNIT_ASSERT_EQUAL( 0., zero.ScalarProduct(otherunit) );
+  CPPUNIT_ASSERT_EQUAL( 0., zero.ScalarProduct(notunit) );
+  CPPUNIT_ASSERT_EQUAL( 1., unit.ScalarProduct(unit) );
+  CPPUNIT_ASSERT_EQUAL( 0., otherunit.ScalarProduct(unit) );
+  CPPUNIT_ASSERT_EQUAL( 0., otherunit.ScalarProduct(unit) );
+  CPPUNIT_ASSERT_EQUAL( 1., otherunit.ScalarProduct(notunit) );
+  CPPUNIT_ASSERT_EQUAL( 2., two.ScalarProduct(unit) );
+  CPPUNIT_ASSERT_EQUAL( 1., two.ScalarProduct(otherunit) );
+  CPPUNIT_ASSERT_EQUAL( 1., two.ScalarProduct(notunit) );
 }
 
@@ -157,9 +159,9 @@
 void VectorTest::EuclidianDistancesTest()
 {
-  CPPUNIT_ASSERT_EQUAL( 1., zero.Distance(&unit) );
-  CPPUNIT_ASSERT_EQUAL( sqrt(2.), otherunit.Distance(&unit) );
-  CPPUNIT_ASSERT_EQUAL( sqrt(2.), zero.Distance(&notunit) );
-  CPPUNIT_ASSERT_EQUAL( 1., otherunit.Distance(&notunit) );
-  CPPUNIT_ASSERT_EQUAL( sqrt(5.), two.Distance(&notunit) );
+  CPPUNIT_ASSERT_EQUAL( 1., zero.distance(unit) );
+  CPPUNIT_ASSERT_EQUAL( sqrt(2.), otherunit.distance(unit) );
+  CPPUNIT_ASSERT_EQUAL( sqrt(2.), zero.distance(notunit) );
+  CPPUNIT_ASSERT_EQUAL( 1., otherunit.distance(notunit) );
+  CPPUNIT_ASSERT_EQUAL( sqrt(5.), two.distance(notunit) );
 }
 
@@ -168,9 +170,9 @@
 void VectorTest::EuclidianAnglesTest()
 {
-  CPPUNIT_ASSERT_EQUAL( M_PI, zero.Angle(&unit) );
-  CPPUNIT_ASSERT_EQUAL( 0., unit.Angle(&unit) );
-  CPPUNIT_ASSERT_EQUAL( true, fabs(M_PI/2. - otherunit.Angle(&unit)) < MYEPSILON );
-  CPPUNIT_ASSERT_EQUAL( true, fabs(M_PI/2. - unit.Angle(&notunit)) < MYEPSILON );
-  CPPUNIT_ASSERT_EQUAL( true, fabs(M_PI/4. - otherunit.Angle(&notunit)) < MYEPSILON );
+  CPPUNIT_ASSERT_EQUAL( M_PI, zero.Angle(unit) );
+  CPPUNIT_ASSERT_EQUAL( 0., unit.Angle(unit) );
+  CPPUNIT_ASSERT_EQUAL( true, fabs(M_PI/2. - otherunit.Angle(unit)) < MYEPSILON );
+  CPPUNIT_ASSERT_EQUAL( true, fabs(M_PI/2. - unit.Angle(notunit)) < MYEPSILON );
+  CPPUNIT_ASSERT_EQUAL( true, fabs(M_PI/4. - otherunit.Angle(notunit)) < MYEPSILON );
 };
 
@@ -179,9 +181,38 @@
 void VectorTest::ProjectionTest()
 {
-  CPPUNIT_ASSERT_EQUAL( zero, zero.Projection(&unit) );
-  CPPUNIT_ASSERT_EQUAL( zero, otherunit.Projection(&unit) );
-  CPPUNIT_ASSERT_EQUAL( Vector(0.4,0.2,0.),  otherunit.Projection(&two) );
-  CPPUNIT_ASSERT_EQUAL( Vector(0.,1.,0.),  two.Projection(&otherunit) );
-};
+  CPPUNIT_ASSERT_EQUAL( zero, zero.Projection(unit) );
+  CPPUNIT_ASSERT_EQUAL( zero, otherunit.Projection(unit) );
+  CPPUNIT_ASSERT_EQUAL( Vector(0.4,0.2,0.),  otherunit.Projection(two) );
+  CPPUNIT_ASSERT_EQUAL( Vector(0.,1.,0.),  two.Projection(otherunit) );
+};
+
+/**
+ * Unittest for operation with normals
+ */
+void VectorTest::NormalsTest(){
+  Vector testVector;
+  // the zero Vector should produce an error
+  CPPUNIT_ASSERT(!testVector.GetOneNormalVector(zero));
+
+  // first one-component system
+  CPPUNIT_ASSERT(testVector.GetOneNormalVector(unit));
+  CPPUNIT_ASSERT(testVector.ScalarProduct(unit) < MYEPSILON);
+
+  // second one-component system
+  CPPUNIT_ASSERT(testVector.GetOneNormalVector(otherunit));
+  CPPUNIT_ASSERT(testVector.ScalarProduct(otherunit) < MYEPSILON);
+
+  // first two-component system
+  CPPUNIT_ASSERT(testVector.GetOneNormalVector(notunit));
+  CPPUNIT_ASSERT(testVector.ScalarProduct(notunit) < MYEPSILON);
+
+  // second two-component system
+  CPPUNIT_ASSERT(testVector.GetOneNormalVector(two));
+  CPPUNIT_ASSERT(testVector.ScalarProduct(two) < MYEPSILON);
+
+  // three component system
+  CPPUNIT_ASSERT(testVector.GetOneNormalVector(three));
+  CPPUNIT_ASSERT(testVector.ScalarProduct(three) < MYEPSILON);
+}
 
 /** UnitTest for line intersections.
@@ -190,73 +221,64 @@
 {
   // plane at (0,0,0) normal to (1,0,0) cuts line from (0,0,0) to (2,1,0) at ???
-  CPPUNIT_ASSERT_EQUAL( true, fixture.GetIntersectionWithPlane(&unit, &zero, &zero, &two) );
+  CPPUNIT_ASSERT_NO_THROW(fixture = Plane(unit, zero).GetIntersection(zero, two) );
   CPPUNIT_ASSERT_EQUAL( zero, fixture );
 
   // plane at (2,1,0) normal to (0,1,0) cuts line from (1,0,0) to (0,1,1) at ???
-  CPPUNIT_ASSERT_EQUAL( true, fixture.GetIntersectionWithPlane(&otherunit, &two, &unit, &notunit) );
+  CPPUNIT_ASSERT_NO_THROW(fixture = Plane(otherunit, two).GetIntersection( unit, notunit) );
   CPPUNIT_ASSERT_EQUAL( Vector(0., 1., 1.), fixture );
 
   // four vectors equal to zero
-  CPPUNIT_ASSERT_EQUAL( false, fixture.GetIntersectionOfTwoLinesOnPlane(&zero, &zero, &zero, &zero, NULL) );
+  CPPUNIT_ASSERT_THROW(fixture = GetIntersectionOfTwoLinesOnPlane(zero, zero, zero, zero), LinearDependenceException);
+  //CPPUNIT_ASSERT_EQUAL( zero, fixture );
+
+  // four vectors equal to unit
+  CPPUNIT_ASSERT_THROW(fixture = GetIntersectionOfTwoLinesOnPlane(unit, unit, unit, unit), LinearDependenceException);
+  //CPPUNIT_ASSERT_EQUAL( zero, fixture );
+
+  // two equal lines
+  CPPUNIT_ASSERT_NO_THROW(fixture = GetIntersectionOfTwoLinesOnPlane(unit, two, unit, two));
+  CPPUNIT_ASSERT_EQUAL( unit, fixture );
+
+  // line from (1,0,0) to (2,1,0) cuts line from (1,0,0) to (0,1,0) at ???
+  CPPUNIT_ASSERT_NO_THROW( fixture = GetIntersectionOfTwoLinesOnPlane(unit, two, unit, otherunit) );
+  CPPUNIT_ASSERT_EQUAL( unit, fixture );
+
+  // line from (1,0,0) to (0,0,0) cuts line from (0,0,0) to (2,1,0) at ???
+  CPPUNIT_ASSERT_NO_THROW( fixture = GetIntersectionOfTwoLinesOnPlane(unit, zero, zero, two) );
   CPPUNIT_ASSERT_EQUAL( zero, fixture );
 
-  // four vectors equal to unit
-  CPPUNIT_ASSERT_EQUAL( false, fixture.GetIntersectionOfTwoLinesOnPlane(&unit, &unit, &unit, &unit, NULL) );
+  // line from (1,0,0) to (2,1,0) cuts line from (0,0,0) to (0,1,0) at ???
+  CPPUNIT_ASSERT_NO_THROW(fixture = GetIntersectionOfTwoLinesOnPlane(unit, two, zero, otherunit) );
+  CPPUNIT_ASSERT_EQUAL( Vector(0., -1., 0.), fixture );
+};
+
+/** UnitTest for vector rotations.
+ */
+void VectorTest::VectorRotationTest()
+{
+  fixture = Vector(-1.,0.,0.);
+
+  // zero vector does not change
+  fixture = RotateVector(zero,unit, 1.);
   CPPUNIT_ASSERT_EQUAL( zero, fixture );
 
-  // two equal lines
-  CPPUNIT_ASSERT_EQUAL( true, fixture.GetIntersectionOfTwoLinesOnPlane(&unit, &two, &unit, &two, NULL) );
+  fixture = RotateVector(zero, two, 1.);
+  CPPUNIT_ASSERT_EQUAL( zero,  fixture);
+
+  // vector on axis does not change
+  fixture = RotateVector(unit,unit, 1.);
   CPPUNIT_ASSERT_EQUAL( unit, fixture );
 
-  // line from (1,0,0) to (2,1,0) cuts line from (1,0,0) to (0,1,0) at ???
-  CPPUNIT_ASSERT_EQUAL( true, fixture.GetIntersectionOfTwoLinesOnPlane(&unit, &two, &unit, &otherunit, NULL) );
-  CPPUNIT_ASSERT_EQUAL( unit, fixture );
-
-  // line from (1,0,0) to (0,0,0) cuts line from (0,0,0) to (2,1,0) at ???
-  CPPUNIT_ASSERT_EQUAL( true, fixture.GetIntersectionOfTwoLinesOnPlane(&unit, &zero, &zero, &two, NULL) );
-  CPPUNIT_ASSERT_EQUAL( zero, fixture );
-
-  // line from (1,0,0) to (2,1,0) cuts line from (0,0,0) to (0,1,0) at ???
-  CPPUNIT_ASSERT_EQUAL( true, fixture.GetIntersectionOfTwoLinesOnPlane(&unit, &two, &zero, &otherunit, NULL) );
-  CPPUNIT_ASSERT_EQUAL( Vector(0., -1., 0.), fixture );
-};
-
-/** UnitTest for vector rotations.
- */
-void VectorTest::VectorRotationTest()
-{
-  fixture.Init(-1.,0.,0.);
-
-  // zero vector does not change
-  fixture.CopyVector(&zero);
-  fixture.RotateVector(&unit, 1.);
-  CPPUNIT_ASSERT_EQUAL( zero, fixture );
-
-  fixture.RotateVector(&two, 1.);
-  CPPUNIT_ASSERT_EQUAL( zero,  fixture);
-
-  // vector on axis does not change
-  fixture.CopyVector(&unit);
-  fixture.RotateVector(&unit, 1.);
-  CPPUNIT_ASSERT_EQUAL( unit, fixture );
-
-  fixture.RotateVector(&unit, 1.);
-  CPPUNIT_ASSERT_EQUAL( unit, fixture );
-
   // rotations
-  fixture.CopyVector(&otherunit);
-  fixture.RotateVector(&unit, M_PI);
+  fixture = RotateVector(otherunit, unit, M_PI);
   CPPUNIT_ASSERT_EQUAL( Vector(0.,-1.,0.), fixture );
 
-  fixture.CopyVector(&otherunit);
-  fixture.RotateVector(&unit, 2. * M_PI);
+  fixture = RotateVector(otherunit, unit, 2. * M_PI);
   CPPUNIT_ASSERT_EQUAL( otherunit, fixture );
 
-  fixture.CopyVector(&otherunit);
-  fixture.RotateVector(&unit, 0);
+  fixture = RotateVector(otherunit,unit, 0);
   CPPUNIT_ASSERT_EQUAL( otherunit, fixture );
 
-  fixture.Init(0.,0.,1.);
-  fixture.RotateVector(&notunit, M_PI);
+  fixture = RotateVector(Vector(0.,0.,1.), notunit, M_PI);
   CPPUNIT_ASSERT_EQUAL( otherunit, fixture );
 }
@@ -278,17 +300,17 @@
   parallelepiped[8] = 1;
 
-  fixture.CopyVector(zero);
+  fixture = zero;
   CPPUNIT_ASSERT_EQUAL( false, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture.Init(2.5,2.5,2.5);
+  fixture = Vector(2.5,2.5,2.5);
   CPPUNIT_ASSERT_EQUAL( true, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture.Init(1.,1.,1.);
+  fixture = Vector(1.,1.,1.);
   CPPUNIT_ASSERT_EQUAL( false, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture.Init(3.5,3.5,3.5);
+  fixture = Vector(3.5,3.5,3.5);
   CPPUNIT_ASSERT_EQUAL( false, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture.Init(2.,2.,2.);
+  fixture = Vector(2.,2.,2.);
   CPPUNIT_ASSERT_EQUAL( true, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture.Init(2.,3.,2.);
+  fixture = Vector(2.,3.,2.);
   CPPUNIT_ASSERT_EQUAL( true, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
-  fixture.Init(-2.,2.,-1.);
+  fixture = Vector(-2.,2.,-1.);
   CPPUNIT_ASSERT_EQUAL( false, fixture.IsInParallelepiped(Vector(2.,2.,2.), parallelepiped) );
 }
Index: src/unittests/vectorunittest.hpp
===================================================================
--- src/unittests/vectorunittest.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/unittests/vectorunittest.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -26,4 +26,5 @@
     CPPUNIT_TEST ( EuclidianAnglesTest );
     CPPUNIT_TEST ( ProjectionTest );
+    CPPUNIT_TEST ( NormalsTest );
     CPPUNIT_TEST ( LineIntersectionTest );
     CPPUNIT_TEST ( VectorRotationTest );
@@ -43,4 +44,5 @@
     void EuclidianAnglesTest();
     void ProjectionTest();
+    void NormalsTest();
     void LineIntersectionTest();
     void VectorRotationTest();
@@ -56,4 +58,5 @@
     Vector notunit;
     Vector two;
+    Vector three;
 };
 
